diff --git a/src/main/process.c b/src/main/process.c
index 98e3633906..52f9df8773 100644
--- a/src/main/process.c
+++ b/src/main/process.c
@@ -74,8 +74,14 @@ static char const *action_codes[] = {
 	"dup",
 	"timer",
 #ifdef WITH_PROXY
-	"proxy-reply"
-#endif
+	"proxy-reply",
+#endif
+	"request was cancelled",
+	"conflicting packet was received",
+	"max_time was reached",
+	"internal failure",
+	"cleanup_delay was reached",
+	"CoA packet was cancelled, and not sent",
 };
 
 #ifdef DEBUG_STATE_MACHINE
@@ -632,9 +638,10 @@ static void proxy_reply_too_late(REQUEST *request)
  *	}
  *  \enddot
  */
-static void request_done(REQUEST *request, int action)
+static void request_done(REQUEST *request, int original)
 {
 	struct timeval now, when;
+	int action = original;
 
 	VERIFY_REQUEST(request);
 
@@ -700,7 +707,7 @@ static void request_done(REQUEST *request, int action)
 	/*
 	 *	If it was administratively canceled, then it's done.
 	 */
-	if (action == FR_ACTION_CANCELLED) {
+	if (action >= FR_ACTION_CANCELLED) {
 		action = FR_ACTION_DONE;
 
 #ifdef WITH_COA
@@ -887,9 +894,10 @@ static void request_done(REQUEST *request, int action)
 #endif
 
 	if (request->packet) {
-		RDEBUG2("Cleaning up request packet ID %u with timestamp +%d",
+		RDEBUG2("Cleaning up request packet ID %u with timestamp +%d due to %s",
 			request->packet->id,
-			(unsigned int) (request->timestamp - fr_start_time));
+			(unsigned int) (request->timestamp - fr_start_time),
+			action_codes[original]);
 	} /* else don't print anything */
 
 	ASSERT_MASTER;
@@ -994,8 +1002,7 @@ static bool request_max_time(REQUEST *request)
 	 *	stop" macro already took care of it.
 	 */
 	if (request->child_state == REQUEST_DONE) {
-	done:
-		request_done(request, FR_ACTION_CANCELLED);
+		request_done(request, FR_ACTION_DONE);
 		return true;
 	}
 
@@ -1027,7 +1034,8 @@ static bool request_max_time(REQUEST *request)
 		/*
 		 *	Tell the request that it's done.
 		 */
-		goto done;
+		request_done(request, FR_ACTION_MAX_TIME);
+		return true;
 	}
 
 	/*
@@ -1096,7 +1104,7 @@ static void request_queue_or_run(REQUEST *request,
 			 *	Otherwise we're not going to do anything with
 			 *	it...
 			 */
-			request_done(request, FR_ACTION_CANCELLED);
+			request_done(request, FR_ACTION_INTERNAL_FAILURE);
 			return;
 		}
 #endif
@@ -1212,7 +1220,7 @@ static void request_cleanup_delay(REQUEST *request, int action)
 			return;
 		} /* else it's time to clean up */
 
-		request_done(request, FR_ACTION_DONE);
+		request_done(request, FR_ACTION_CLEANUP_DELAY);
 		break;
 
 	default:
@@ -1346,7 +1354,7 @@ static int request_pre_handler(REQUEST *request, UNUSED int action)
 	}
 
 	if (rcode < 0) {
-		RATE_LIMIT(INFO("Dropping packet without response because of error: %s", fr_strerror()));
+		RATE_LIMIT(INFO("Dropping packet without response because of error: %s (from client %s)", fr_strerror(), request->client->shortname));
 		request->reply->offset = -2; /* bad authenticator */
 		return 0;
 	}
@@ -1802,7 +1810,7 @@ int request_receive(TALLOC_CTX *ctx, rad_listen_t *listener, RADIUS_PACKET *pack
 		 *	the request just as we're logging the
 		 *	complaint.
 		 */
-		request_done(request, FR_ACTION_CANCELLED);
+		request_done(request, FR_ACTION_CONFLICT);
 		request = NULL;
 
 		/*
@@ -1891,7 +1899,7 @@ skip_dup:
 	if (!listener->nodup) {
 		if (!rbtree_insert(pl, &request->packet)) {
 			RERROR("Failed to insert request in the list of live requests: discarding it");
-			request_done(request, FR_ACTION_CANCELLED);
+			request_done(request, FR_ACTION_INTERNAL_FAILURE);
 			return 1;
 		}
 
@@ -2094,11 +2102,7 @@ static void tcp_socket_timer(void *ctx)
 			 *	open to listen for replies to requests we had
 			 *	previously sent.
 			 */
-			if (listener->type == RAD_LISTEN_PROXY
-#ifdef WITH_COA_TUNNEL
-			    || listener->send_coa
-#endif
-				) {
+			if (listener->type == RAD_LISTEN_PROXY) {
 				PTHREAD_MUTEX_LOCK(&proxy_mutex);
 				if (!fr_packet_list_socket_freeze(proxy_list,
 								  listener->fd)) {
@@ -2223,16 +2227,6 @@ static void remove_from_proxy_hash_nl(REQUEST *request, bool yank)
 
 	if (!request->in_proxy_hash) return;
 
-#ifdef COA_TUNNEL
-	/*
-	 *	Track how many IDs are used.  This information
-	 *	helps the listen_coa_find() function get a
-	 *	listener which has free IDs.
-	 */
-	rad_assert(request->proxy_listener->num_ids_used > 0);
-	request->proxy_listener->num_ids_used--;
-#endif
-
 	fr_packet_list_id_free(proxy_list, request->proxy, yank);
 	request->in_proxy_hash = false;
 
@@ -2276,11 +2270,9 @@ static void remove_from_proxy_hash_nl(REQUEST *request, bool yank)
 		}
 	}
 
-#ifdef WITH_TCP
 	if (request->proxy_listener) {
 		request->proxy_listener->count--;
 	}
-#endif
 	request->proxy_listener = NULL;
 
 	/*
@@ -2335,9 +2327,6 @@ static int insert_into_proxy_hash(REQUEST *request)
 	int tries;
 	bool success = false;
 	void *proxy_listener;
-#ifdef WITH_COA_TUNNEL
-	bool reverse_coa = request->proxy_listener && (request->proxy_listener->type != RAD_LISTEN_PROXY);
-#endif
 
 	VERIFY_REQUEST(request);
 
@@ -2361,41 +2350,22 @@ static int insert_into_proxy_hash(REQUEST *request)
 						  &request->proxy, &proxy_listener);
 		if (success) break;
 
-#ifdef WITH_COA_TUNNEL
-		/*
-		 *	Can't allocate an ID here, try to grab another
-		 *	listener by key.
-		 */
-		if (reverse_coa) {
-			int rcode;
-			VALUE_PAIR *vp;
-
-			/*
-			 *	Find the Originating-Realm key, which
-			 *	might not be the same as
-			 *	proxy_listener->key.
-			 */
-			vp = fr_pair_find_by_num(request->config, PW_PROXY_TO_ORIGINATING_REALM, 0, TAG_ANY);
-			if (!vp) break;
-
-			/*
-			 *	We don't want to hold multiple mutexes
-			 *	at the same time.
-			 */
-			PTHREAD_MUTEX_UNLOCK(&proxy_mutex);
-			rcode = listen_coa_find(request, vp->vp_strvalue);
-			PTHREAD_MUTEX_LOCK(&proxy_mutex);
-			if (rcode < 0) continue;
-			break;
-		}
-#endif
-
 		if (tries > 0) continue; /* try opening new socket only once */
 
 #ifdef HAVE_PTHREAD_H
 		if (proxy_no_new_sockets) break;
 #endif
 
+		/*
+		 *	Don't try to add a new listener if it's not possible.
+		 */
+		if (fr_event_list_full(el)) {
+			RATE_LIMIT(ERROR("Cannot open a new proxy socket - too many sockets are already open"));
+			request->home_server->state = HOME_STATE_CONNECTION_FAIL;
+			PTHREAD_MUTEX_UNLOCK(&proxy_mutex);
+			goto fail;
+		}
+
 		RDEBUG3("proxy: Trying to open a new listener to the home server");
 		this = proxy_new_listener(proxy_ctx, request->home_server, 0);
 		if (!this) {
@@ -2429,15 +2399,6 @@ static int insert_into_proxy_hash(REQUEST *request)
 			goto fail;
 		}
 
-#ifdef COA_TUNNEL
-		/*
-		 *	Track how many IDs are used.  This information
-		 *	helps the listen_coa_find() function get a
-		 *	listener which has free IDs.
-		 */
-		request->proxy_listener->num_ids_used++;
-#endif
-
 		/*
 		 *	Add it to the event loop.  Ensure that we have
 		 *	only one mutex locked at a time.
@@ -2469,9 +2430,7 @@ static int insert_into_proxy_hash(REQUEST *request)
 	 */
 	request->home_server->currently_outstanding++;
 
-#ifdef WITH_TCP
 	request->proxy_listener->count++;
-#endif
 
 	PTHREAD_MUTEX_UNLOCK(&proxy_mutex);
 
@@ -2490,9 +2449,6 @@ static int process_proxy_reply(REQUEST *request, RADIUS_PACKET *reply)
 	int post_proxy_type = 0;
 	VALUE_PAIR *vp;
 	char const *old_server;
-#ifdef WITH_COA_TUNNEL
-	bool reverse_coa = false;
-#endif
 
 	VERIFY_REQUEST(request);
 
@@ -2556,15 +2512,6 @@ static int process_proxy_reply(REQUEST *request, RADIUS_PACKET *reply)
 	if (post_proxy_type > 0) RDEBUG2("Found Post-Proxy-Type %s",
 					 dict_valnamebyattr(PW_POST_PROXY_TYPE, 0, post_proxy_type));
 
-#ifdef WITH_COA_TUNNEL
-	/*
-	 *	Cache this, as request->proxy_listener will be
-	 *	NULL after removing the request from the proxy
-	 *	hash.
-	 */
-	if (request->proxy_listener) reverse_coa = request->proxy_listener->type != RAD_LISTEN_PROXY;
-#endif
-
 	if (reply) {
 		VERIFY_PACKET(reply);
 
@@ -2602,15 +2549,6 @@ static int process_proxy_reply(REQUEST *request, RADIUS_PACKET *reply)
 	if (request->home_server && request->home_server->virtual_server) {
 		request->server = request->home_server->virtual_server;
 
-#ifdef WITH_COA_TUNNEL
-	} else if (reverse_coa) {
-		rad_assert((request->proxy->code == PW_CODE_COA_REQUEST) ||
-			   (request->proxy->code == PW_CODE_DISCONNECT_REQUEST));
-		rad_assert(request->home_server != NULL);
-		rad_assert(request->home_server->recv_coa_server != NULL);
-		request->server = request->home_server->recv_coa_server;
-#endif
-
 	} else if (request->home_pool && request->home_pool->virtual_server) {
 			request->server = request->home_pool->virtual_server;
 	}
@@ -3241,36 +3179,6 @@ static int request_will_proxy(REQUEST *request)
 
 		return 0;
 
-#ifdef WITH_COA_TUNNEL
-	} else if (((request->packet->code == PW_CODE_COA_REQUEST) ||
-		    (request->packet->code == PW_CODE_DISCONNECT_REQUEST)) &&
-		   ((vp = fr_pair_find_by_num(request->config, PW_PROXY_TO_ORIGINATING_REALM, 0, TAG_ANY)) != NULL)) {
-
-		/*
-		 *	This function will set request->home_server,
-		 *	and also request->proxy_listener.
-		 */
-		if (listen_coa_find(request, vp->vp_strvalue) < 0) {
-			vp_cursor_t cursor;
-
-			(void) fr_cursor_init(&cursor, &request->config); /* already checked it above */
-
-			while ((vp = fr_cursor_next(&cursor)) != NULL) {
-				if (listen_coa_find(request, vp->vp_strvalue) == 0) break;
-			}
-
-			/*
-			 *	Not found.
-			 */
-			return 0;
-		}
-
-		/*
-		 *	Initialise request->proxy, and copy VPs over.
-		 */
-		home_server_update_request(request->home_server, request);
-		goto add_proxy_state;
-#endif
 	} else {
 
 		return 0;
@@ -3303,7 +3211,7 @@ do_home:
 	 *	Once we've decided to proxy a request, we cannot send
 	 *	a CoA packet.  So we free up any CoA packet here.
 	 */
-	if (request->coa) request_done(request->coa, FR_ACTION_CANCELLED);
+	if (request->coa) request_done(request->coa, FR_ACTION_COA_CANCELLED);
 #endif
 
 	/*
@@ -3368,10 +3276,6 @@ do_home:
 	 *	The RFC's say we have to do this, but FreeRADIUS
 	 *	doesn't need it.
 	 */
-#ifdef WITH_COA_TUNNEL
-add_proxy_state:
-#endif
-
 	vp = radius_pair_create(request->proxy, &request->proxy->vps, PW_PROXY_STATE, 0);
 	fr_pair_value_sprintf(vp, "%u", request->packet->id);
 
@@ -3402,15 +3306,6 @@ add_proxy_state:
 	if (request->home_server && request->home_server->virtual_server) {
 		request->server = request->home_server->virtual_server;
 
-#ifdef WITH_COA_TUNNEL
-	} else if (request->proxy_listener && (request->proxy_listener->type != RAD_LISTEN_PROXY)) {
-		rad_assert((request->packet->code == PW_CODE_COA_REQUEST) ||
-			   (request->packet->code == PW_CODE_DISCONNECT_REQUEST));
-		rad_assert(request->home_server != NULL);
-		rad_assert(request->home_server->recv_coa_server != NULL);
-		request->server = request->home_server->recv_coa_server;
-#endif
-
 	} else {
 		char buffer[128];
 
@@ -3532,7 +3427,7 @@ static int request_proxy(REQUEST *request)
 #ifdef WITH_COA
 	if (request->coa) {
 		RWDEBUG("Cannot proxy and originate CoA packets at the same time.  Cancelling CoA request");
-		request_done(request->coa, FR_ACTION_CANCELLED);
+		request_done(request->coa, FR_ACTION_COA_CANCELLED);
 	}
 #endif
 
@@ -4444,26 +4339,6 @@ static void request_coa_originate(REQUEST *request)
 	coa = request->coa;
 	coa->listener = NULL;	/* copied here by request_alloc_fake(), but not needed */
 
-#ifdef WITH_COA_TUNNEL
-	/*
-	 *	Proxy-To-Originating-Realm is preferred to any other
-	 *	method of originating CoA requests.
-	 */
-	vp = fr_pair_find_by_num(coa->proxy->vps, PW_PROXY_TO_ORIGINATING_REALM, 0, TAG_ANY);
-	if (vp) {
-		/*
-		 *	This function will set request->home_server,
-		 *	and also request->proxy_listener.
-		 */
-		if (listen_coa_find(coa, vp->vp_strvalue) < 0) {
-			RWDEBUG("Unknown Originating realm '%s'", vp->vp_strvalue);
-			return;
-		}
-
-		goto set_packet_type;
-	}
-#endif
-
 	/*
 	 *	src_ipaddr will be set up in proxy_encode.
 	 */
@@ -4529,9 +4404,6 @@ static void request_coa_originate(REQUEST *request)
 		}
 	}
 
-#ifdef WITH_COA_TUNNEL
-set_packet_type:
-#endif
 	vp = fr_pair_find_by_num(coa->proxy->vps, PW_PACKET_TYPE, 0, TAG_ANY);
 	if (vp) {
 		switch (vp->vp_integer) {
@@ -4585,15 +4457,6 @@ set_packet_type:
 	if (coa->home_server && coa->home_server->virtual_server) {
 		coa->server = coa->home_server->virtual_server;
 
-#ifdef WITH_COA_TUNNEL
-	} else if (coa->proxy_listener && (coa->proxy_listener->type != RAD_LISTEN_PROXY)) {
-		rad_assert((coa->proxy->code == PW_CODE_COA_REQUEST) ||
-			   (coa->proxy->code == PW_CODE_DISCONNECT_REQUEST));
-		rad_assert(coa->home_server != NULL);
-		rad_assert(coa->home_server->recv_coa_server != NULL);
-		coa->server = coa->home_server->recv_coa_server;
-#endif
-
 	} else if (coa->home_pool && coa->home_pool->virtual_server) {
 		coa->server = coa->home_pool->virtual_server;
 	}
@@ -4698,7 +4561,7 @@ static void coa_retransmit(REQUEST *request)
 	    request->proxy_reply ||
 	    !request->proxy_listener ||
 	    (request->proxy_listener->status >= RAD_LISTEN_STATUS_EOL)) {
-		request_done(request, FR_ACTION_CANCELLED);
+		request_done(request, FR_ACTION_COA_CANCELLED);
 		return;
 	}
 
@@ -4853,7 +4716,7 @@ static bool coa_max_time(REQUEST *request)
 	 */
 	if (request->child_state == REQUEST_DONE) {
 	done:
-		request_done(request, FR_ACTION_CANCELLED);
+		request_done(request, FR_ACTION_MAX_TIME);
 		return true;
 	}
 
@@ -5311,23 +5174,20 @@ static void event_new_fd(rad_listen_t *this)
 		rad_assert(sock != NULL);
 		if (just_started) {
 			DEBUG("Listening on %s", buffer);
-		} else {
-			INFO(" ... adding new socket %s", buffer);
-		}
 
 #ifdef WITH_PROXY
-		if (!just_started && (this->type == RAD_LISTEN_PROXY)) {
-			home_server_t *home;
-			
-			home = sock->home;
-			if (!home || !home->limit.max_connections) {
-				INFO(" ... adding new socket %s", buffer);
-			} else {
+		} else if (this->type == RAD_LISTEN_PROXY) {
+			home_server_t *home = sock->home;
+
+			if (home && home->limit.max_connections) {
 				INFO(" ... adding new socket %s (%u of %u)", buffer,
 				     home->limit.num_connections, home->limit.max_connections);
+			} else {
+				INFO(" ... adding new socket %s", buffer);
 			}
-
 #endif
+		} else {
+			INFO(" ... adding new socket %s", buffer);
 		}
 
 		switch (this->type) {
@@ -5416,31 +5276,6 @@ static void event_new_fd(rad_listen_t *this)
 					fr_exit(1);
 				}
 			}
-
-#ifdef WITH_COA_TUNNEL
-			/*
-			 *	If we're allowed to send CoA requests
-			 *	back down this incoming socket, then
-			 *	add the socket to the proxy listener
-			 *	list.  We need to check for "parent",
-			 *	as the main incoming listener has
-			 *	"send_coa" set, but it just calls
-			 *	accept(), and doesn't actually send
-			 *	any packets.
-			 */
-			if (this->send_coa && this->parent) {
-				PTHREAD_MUTEX_LOCK(&proxy_mutex);
-				if (!fr_packet_list_socket_add(proxy_list, this->fd,
-							       sock->proto,
-							       &sock->other_ipaddr, sock->other_port,
-							       this)) {
-					ERROR("Failed adding coa proxy socket");
-					fr_exit_now(1);
-				}
-				PTHREAD_MUTEX_UNLOCK(&proxy_mutex);
-			}
-#endif	/* WITH_COA_TUNNEL */
-
 #endif	/* WITH_TCP */
 			break;
 		} /* switch over listener types */
@@ -5455,8 +5290,18 @@ static void event_new_fd(rad_listen_t *this)
 			return;
 		}
 
-		ERROR("Failed adding event handler for socket: %s", fr_strerror());
-		this->status = RAD_LISTEN_STATUS_REMOVE_NOW;
+		/*
+		 *	Print out which socket failed.
+		 *
+		 *	If we're trying to add the socket, then
+		 *	forcibly remove it immediately, without any
+		 *	additional cleanups.  There cannot, and MUST
+		 *	NOT be any packets associated with the socket.
+		 */
+		this->print(this, buffer, sizeof(buffer));
+		ERROR("Failed adding event handler for socket %s: %s", buffer, fr_strerror());
+		this->status = RAD_LISTEN_STATUS_EOL;
+		goto listener_is_eol;
 	} /* end of INIT */
 
 	if (this->status == RAD_LISTEN_STATUS_PAUSE) {
@@ -5509,15 +5354,12 @@ static void event_new_fd(rad_listen_t *this)
 		 */
 		fr_event_fd_delete(el, 0, this->fd);
 
+	listener_is_eol:
 #ifdef WITH_PROXY
 		/*
 		 *	Tell all requests using this socket that the socket is dead.
 		 */
-		if (this->type == RAD_LISTEN_PROXY
-#ifdef WITH_COA_TUNNEL
-		    || (this->send_coa && this->parent)
-#endif
-			) {
+		if (this->type == RAD_LISTEN_PROXY) {
 			PTHREAD_MUTEX_LOCK(&proxy_mutex);
 			if (!fr_packet_list_socket_freeze(proxy_list,
 							  this->fd)) {
@@ -5612,11 +5454,7 @@ static void event_new_fd(rad_listen_t *this)
 		 *	to stop using it.  And then remove it from the
 		 *	list of outgoing sockets.
 		 */
-		if (this->type == RAD_LISTEN_PROXY
-#ifdef WITH_COA_TUNNEL
-		    || (this->send_coa && this->parent)
-#endif
-			) {
+		if (this->type == RAD_LISTEN_PROXY) {
 			home_server_t *home;
 
 			home = sock->home;
@@ -5636,37 +5474,15 @@ static void event_new_fd(rad_listen_t *this)
 				fr_exit(1);
 			}
 			PTHREAD_MUTEX_UNLOCK(&proxy_mutex);
-
-#ifdef WITH_COA_TUNNEL
-			/*
-			 *	Clean up the proxied packets AND the
-			 *	normal one.
-			 */
-			if (this->send_coa && this->parent) goto shutdown;
-#endif
-
 		} else
 #endif	/* WITH_PROXY */
 		{
-#ifdef WITH_COA_TUNNEL
-		shutdown:
-#endif
 			INFO(" ... shutting down socket %s", buffer);
 
 			/*
 			 *	EOL all requests using this socket.
 			 */
 			rbtree_walk(pl, RBTREE_DELETE_ORDER, eol_listener, this);
-
-#ifdef WITH_COA_TUNNEL
-			/*
-			 *	Delete the listener from the set of
-			 *	listeners by key.  This is done early,
-			 *	so that it won't be used while the
-			 *	cleanup timers are being run.
-			 */
-			if (this->tls) this->dead = true;
-#endif
 		}
 
 		/*
diff --git a/src/main/radclient.c b/src/main/radclient.c
index 5d8f49f58a..09d27c8711 100644
--- a/src/main/radclient.c
+++ b/src/main/radclient.c
@@ -28,6 +28,10 @@ RCSID("$Id$")
 #include <freeradius-devel/radpaths.h>
 #include <freeradius-devel/udpfromto.h>
 #include <freeradius-devel/conf.h>
+#ifdef HAVE_OPENSSL_SSL_H
+#include <openssl/ssl.h>
+#include <freeradius-devel/openssl3.h>
+#endif
 #include <ctype.h>
 
 #ifdef HAVE_GETOPT_H
@@ -36,6 +40,8 @@ RCSID("$Id$")
 
 #include <assert.h>
 
+USES_APPLE_DEPRECATED_API
+
 typedef struct REQUEST REQUEST;	/* to shut up warnings about mschap.h */
 
 #include "smbdes.h"
@@ -155,9 +161,60 @@ static int _rc_request_free(rc_request_t *request)
 	return 0;
 }
 
+#if defined(OPENSSL_VERSION_NUMBER) && OPENSSL_VERSION_NUMBER >= 0x30000000L
+#  include <openssl/provider.h>
+
+static OSSL_PROVIDER *openssl_default_provider = NULL;
+static OSSL_PROVIDER *openssl_legacy_provider = NULL;
+
+static int openssl3_init(void)
+{
+	/*
+	 *	Load the default provider for most algorithms
+	 */
+	openssl_default_provider = OSSL_PROVIDER_load(NULL, "default");
+	if (!openssl_default_provider) {
+		ERROR("(TLS) Failed loading default provider");
+		return -1;
+	}
+
+	/*
+	 *	Needed for MD4
+	 *
+	 *	https://www.openssl.org/docs/man3.0/man7/migration_guide.html#Legacy-Algorithms
+	 */
+	openssl_legacy_provider = OSSL_PROVIDER_load(NULL, "legacy");
+	if (!openssl_legacy_provider) {
+		ERROR("(TLS) Failed loading legacy provider");
+		return -1;
+	}
+
+	return 0;
+}
+
+static void openssl3_free(void)
+{
+	if (openssl_default_provider && !OSSL_PROVIDER_unload(openssl_default_provider)) {
+		ERROR("Failed unloading default provider");
+	}
+	openssl_default_provider = NULL;
+
+	if (openssl_legacy_provider && !OSSL_PROVIDER_unload(openssl_legacy_provider)) {
+		ERROR("Failed unloading legacy provider");
+	}
+	openssl_legacy_provider = NULL;
+}
+#else
+#define openssl3_init()
+#define openssl3_free()
+#endif
+
+
+
 static int mschapv1_encode(RADIUS_PACKET *packet, VALUE_PAIR **request,
 			   char const *password)
 {
+	int rcode;
 	unsigned int i;
 	uint8_t *p;
 	VALUE_PAIR *challenge, *reply;
@@ -190,9 +247,8 @@ static int mschapv1_encode(RADIUS_PACKET *packet, VALUE_PAIR **request,
 
 	p[1] = 0x01; /* NT hash */
 
-	if (mschap_ntpwdhash(nthash, password) < 0) {
-		return 0;
-	}
+	rcode = mschap_ntpwdhash(nthash, password);
+	if (rcode < 0) return 0;
 
 	smbdes_mschap(nthash, challenge->vp_octets, p + 26);
 	return 1;
@@ -1423,6 +1479,8 @@ int main(int argc, char **argv)
 		exit(1);
 	}
 
+	openssl3_init();
+
 	/*
 	 *	Bind to the first specified IP address and port.
 	 *	This means we ignore later ones.
@@ -1639,5 +1697,8 @@ int main(int argc, char **argv)
 	if ((stats.lost > 0) || (stats.failed > 0)) {
 		exit(1);
 	}
+
+	openssl3_free();
+
 	exit(0);
 }
diff --git a/src/main/radiusd.c b/src/main/radiusd.c
index 06b566d073..9739514509 100644
--- a/src/main/radiusd.c
+++ b/src/main/radiusd.c
@@ -694,13 +694,6 @@ cleanup:
 	 */
 	main_config_free();
 
-#ifdef WITH_COA_TUNNEL
-	/*
-	 *	This should be after freeing all of the listeners.
-	 */
-	listen_coa_free();
-#endif
-
 #ifdef WIN32
 	WSACleanup();
 #endif
diff --git a/src/main/realms.c b/src/main/realms.c
index ad5f546639..063c49d700 100644
--- a/src/main/realms.c
+++ b/src/main/realms.c
@@ -73,10 +73,6 @@ static const FR_NAME_NUMBER home_server_types[] = {
 	{ "acct",		HOME_TYPE_ACCT },
 	{ "auth+acct",		HOME_TYPE_AUTH_ACCT },
 	{ "coa",		HOME_TYPE_COA },
-#ifdef WITH_COA_TUNNEL
-	{ "auth+coa",		HOME_TYPE_AUTH_COA },
-	{ "auth+acct+coa",	HOME_TYPE_AUTH_ACCT_COA },
-#endif
 	{ NULL, 0 }
 };
 
@@ -100,7 +96,7 @@ static realm_config_t *realm_config = NULL;
 static rbtree_t	*home_servers_byaddr = NULL;
 static rbtree_t	*home_servers_byname = NULL;
 #ifdef WITH_STATS
-static int home_server_max_number = 0;
+int home_server_max_number = 0;
 static rbtree_t	*home_servers_bynumber = NULL;
 #endif
 
@@ -437,16 +433,6 @@ static CONF_PARSER home_server_coa[] = {
 	{ "mrd",  FR_CONF_OFFSET(PW_TYPE_INTEGER, home_server_t, coa_mrd), STRINGIFY(30) },
 	CONF_PARSER_TERMINATOR
 };
-
-
-
-#ifdef WITH_COA_TUNNEL
-static CONF_PARSER home_server_recv_coa[] = {
-	{ "virtual_server",  FR_CONF_OFFSET(PW_TYPE_STRING, home_server_t, recv_coa_server), NULL },
-	CONF_PARSER_TERMINATOR
-};
-#endif
-
 #endif
 
 static CONF_PARSER home_server_config[] = {
@@ -496,9 +482,6 @@ static CONF_PARSER home_server_config[] = {
 
 #ifdef WITH_COA
 	{ "coa", FR_CONF_POINTER(PW_TYPE_SUBSECTION, NULL), (void const *) home_server_coa },
-#ifdef WITH_COA_TUNNEL
-	{ "recv_coa", FR_CONF_POINTER(PW_TYPE_SUBSECTION, NULL), (void const *) home_server_recv_coa },
-#endif
 #endif
 
 	CONF_PARSER_TERMINATOR
@@ -698,20 +681,6 @@ bool realm_home_server_add(home_server_t *home)
 		}
 	}
 
-#ifdef WITH_COA_TUNNEL
-	if (home->recv_coa) {
-		if (!home->tls) {
-			ERROR("TLS is required in order to accept CoA requests from a home server");
-			return false;
-		}
-
-		if (!home->recv_coa_server) {
-			ERROR("A 'virtual_server' configuration is required in order to accept CoA requests from a home server");
-			return false;
-		}
-	}
-#endif
-
 	/*
 	 *	Mark it as already processed
 	 */
@@ -824,17 +793,6 @@ home_server_t *home_server_afrom_cs(TALLOC_CTX *ctx, realm_config_t *rc, CONF_SE
 				goto error;
 			}
 			break;
-
-#ifdef WITH_COA_TUNNEL
-		case HOME_TYPE_AUTH_ACCT_COA:
-			home->dual = true;
-			home->recv_coa = true;
-			break;
-
-		case HOME_TYPE_AUTH_COA:
-			home->recv_coa = true;
-			break;
-#endif
 #endif
 
   		case HOME_TYPE_INVALID:
@@ -861,10 +819,6 @@ home_server_t *home_server_afrom_cs(TALLOC_CTX *ctx, realm_config_t *rc, CONF_SE
 			}
 
 			if (((home->type == HOME_TYPE_AUTH) ||
-#ifdef WITH_COA_TUNNEL
-			     (home->type == HOME_TYPE_AUTH_COA) ||
-			     (home->type == HOME_TYPE_AUTH_ACCT_COA) ||
-#endif
 			     (home->type == HOME_TYPE_AUTH_ACCT)) && !home->ping_user_password) {
 				cf_log_err_cs(cs, "You must supply a 'password' to enable status_check=request");
 				goto error;
@@ -930,38 +884,6 @@ home_server_t *home_server_afrom_cs(TALLOC_CTX *ctx, realm_config_t *rc, CONF_SE
 	}
 #endif
 
-	/*
-	 *	Check the reverse CoA configuration.
-	 */
-#ifdef WITH_COA_TUNNEL
-	if (home->recv_coa) {
-		if (!tls) {
-			ERROR("TLS is required in order to accept CoA requests from a home server");
-			goto error;
-		}
-
-		if (!home->recv_coa_server) {
-			ERROR("A 'virtual_server' configuration is required in order to accept CoA requests from a home server");
-			goto error;
-		}
-
-		/*
-		 *	Try and find a 'server' section off the root of
-		 *	the config with a name that matches the coa
-		 *	virtual_server.
-		 */
-		if (!rc) {
-			ERROR("Dynamic home servers cannot accept CoA requests");
-			goto error;
-		}
-
-		if (!cf_section_sub_find_name2(rc->cs, "server", home->recv_coa_server)) {
-			cf_log_err_cs(cs, "No such coa server %s", home->recv_coa_server);
-			goto error;
-		}
-	}
-#endif
-
 	/*
 	 *	If were doing RADSEC (tls+tcp) the secret should default
 	 *	to radsec, else a secret must be set.
@@ -1206,16 +1128,6 @@ static int pool_check_home_server(UNUSED realm_config_t *rc, CONF_PAIR *cp,
 	case HOME_TYPE_ACCT:
 		myhome.type = HOME_TYPE_AUTH_ACCT;
 		home = rbtree_finddata(home_servers_byname, &myhome);
-#ifdef WITH_COA_TUNNEL
-		if (!home) {
-			myhome.type = HOME_TYPE_AUTH_COA;
-			home = rbtree_finddata(home_servers_byname, &myhome);
-			if(!home) {
-				myhome.type = HOME_TYPE_AUTH_ACCT_COA;
-				home = rbtree_finddata(home_servers_byname, &myhome);
-			}
-		}
-#endif
 		if (home) {
 			*phome = home;
 			return 1;
@@ -1507,16 +1419,6 @@ static int server_pool_add(realm_config_t *rc,
 			case HOME_TYPE_ACCT:
 				myhome.type = HOME_TYPE_AUTH_ACCT;
 				home = rbtree_finddata(home_servers_byname, &myhome);
-#ifdef WITH_COA_TUNNEL
-				if (!home) {
-					myhome.type = HOME_TYPE_AUTH_COA;
-					home = rbtree_finddata(home_servers_byname, &myhome);
-					if (!home) {
-						myhome.type = HOME_TYPE_AUTH_ACCT_COA;
-						home = rbtree_finddata(home_servers_byname, &myhome);
-					}
-				}
-#endif
 				break;
 
 			default:
@@ -3086,14 +2988,6 @@ int home_server_afrom_file(char const *filename)
 		goto error;
 	}
 
-#ifdef COA_TUNNEL
-	if (home->recv_coa) {
-		fr_strerror_printf("Dynamic home_server '%s' cannot receive CoA requests'", p);
-		talloc_free(home);
-		goto error;
-	}
-#endif
-
 	if (!realm_home_server_add(home)) {
 		fr_strerror_printf("Failed adding home_server to the internal data structures");
 		talloc_free(home);
